''=============================================================================
'' @file     sensirion_i2c_SPD.spin   version 0.5   is demo of basic funtionality
'' @target   Propeller with Sensirion SHT2x modified for sensirion SPD610
'' @author   Thomas Tracy Allen, EME Systems
'' Copyright (c) 2013 EME Systems LLC
'' See end of file for terms of use.
'' version 1.0
'' uses integer math to return values directly in degC*100 and %RH*10
'  bad read or out-of-range are returned as negx
'' no floating point required
''
''=============================================================================

CON
  _clkmode = xtal1 + pll8x                '
  _xinfreq = 5_000_000



  DEV_ID = %1000_000            ' SPD device ID on i2c buss
  TRIGGER = %1111_0001          ' SPD command to trigger measurement
  SHT21_TEMP_HOLD =  %1110_0011 ' SHT21 command to trigger temperature measurement using clock hold


OBJ
  i2c : "i2c_123"
  pst : "parallax_serial_terminal"

           
VAR
  long  t100
  byte  dpin, cpin, mode

PUB demo | raw
  pst.Start(9600)
  Pause(100)
  i2c.Init(6,7)

  pst.str(string(13,"top of SHT21 demo"))


  repeat
    raw := ReadRawPressureHold
    pst.char(13)
    pst.dec(raw)

    Pause(1000)


PUB readRawPressureHold
  result := i2c.ReadNumber(DEV_ID, TRIGGER, -2)


PUB Pause(ms)
  waitcnt(clkfreq/1000*ms+cnt)



{{
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
}}
